// DXMouseCapture.h: interface for the CDXMouseCapture class.
//
//////////////////////////////////////////////////////////////////////


// DXMouseCapture
//
// Wrapper Class for DirectInput Mouse capturing
//
// Implemented 10.2002, Martin Gernss.



#if !defined(AFX_DXMOUSECAPTURE_H__5E33233F_23CA_47C9_AF3A_D929E6173C8C__INCLUDED_)
#define AFX_DXMOUSECAPTURE_H__5E33233F_23CA_47C9_AF3A_D929E6173C8C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef DIRECTINPUT_VERSION
#define DIRECTINPUT_VERSION         0x0800
#endif  //DIRECTINPUT_VERSION

#include "dinput.h"

class CDXMouseCapture  
{
public:
	bool IsCapturing() const;
  // Returns TRUE if capturing is enabled, otherwise FALSE

	bool GetAxis(int &nX, int &nY, int &nZ);
  // Stores the relative changes of the mouse axes in the corresponding parameters

  bool GetButtons(unsigned char &but1, unsigned char &but2);
  // Stores the current state of the first two buttons in the corresponding parameters

	void Stop();
  // Stops the capturing

	bool Start();
  // Starts the capturing (necessary to retreive data with the GetAxis and GetButtons functions)

	bool Init(HINSTANCE hInstance, HWND hWnd);
  // Initializes DirectInput

	CDXMouseCapture();
	virtual ~CDXMouseCapture();
  // Releases DirectInput Interfaces

protected:
	bool m_bCapture;
	LPDIRECTINPUT8 m_pDI;
	LPDIRECTINPUTDEVICE8 m_pMouse;
private:
	bool m_bInitOK;
	int m_nSuccessfulSteps;
};

#endif // !defined(AFX_DXMOUSECAPTURE_H__5E33233F_23CA_47C9_AF3A_D929E6173C8C__INCLUDED_)
