// scene.cpp

#include "stdafx.h"


#include "pingpong.h"
#include "objects.h"


#include "scene.h"


void Scene::invoke(NxScene& scene)
{
	/*g_app.dynamics->poseChangeNotify();
	g_app.dynamics->findContacts(*g_app.statics, *this);      // CollisionSDK inactive
  g_app.dynamics->findContacts(*g_app.dynamics, *this);*/
  gr->checkCollision(bl);
  tb->checkCollision(bl); // Own collision detection
  tb2->checkCollision(bl);
  rack->checkCollision(bl);
  net->checkCollision(bl);
}

void Scene::contact(NxShape& s1, NxShape& s2, NxcReal separation, 
	  const NxcVec3& contactPoint, const NxcVec3& contactNormal) {    // CollisionSDK inactive

/*  bl->color[0] = 1.0;
  bl->color[1] = 0.0;
  bl->color[2] = 0.0;

  Generalobject* g1 = (Generalobject*) s1.getUserData();
  Generalobject* g2 = (Generalobject*) s2.getUserData();

  NxBody* b1 = g1->nxbody;
  NxBody* b2 = g2->nxbody;

  if(g1->isRacket)
  {
	  NxrVec3 velo;
	  b2->getVelocity(velo);
	  //velo = NxrVec3(0.0f, 0.0f, 0.0f) - velo;
	  //b2->setVelocity(velo);
	  //return;
  }
  if(g2->isRacket)
  {
	  NxrVec3 velo;
	  b1->getVelocity(velo);
	  velo = NxrVec3(0.0f, 0.0f, 0.0f) - velo;
	  b1->setVelocity(contactNormal*1);
	  //return;
  }

  NxContact* contact = g_app.scene->createContact(b1, b2, contactPoint, contactNormal);
  contact->setGeometry(separation);

  NxrReal dynFriction = (g1->dynFriction + g2->dynFriction) / 2;
  NxrReal staFriction = (g1->staFriction + g2->staFriction) / 2;
  contact->setMaterial(0.3f, dynFriction, staFriction);

  //float pos[] = {0,2.1f,-0.8f};
  //insertBall(pos);
  NxrVec3 vvel;
  bl->nxbody->getVelocity(vvel); 
  if (vvel[1] != 0) {
    PlaySound("pong.wav",NULL,SND_FILENAME | SND_ASYNC | SND_NOWAIT);
  }*/
}

void Scene::init() {

  g_app.fsdk = NxCreateFoundationSDK( NX_FOUNDATION_SDK_VERSION,NULL,NULL);
  if (!g_app.fsdk) {
    MessageBox(NULL,"Wrong NxFoundation.DLL version?","Error",MB_ICONSTOP);
  }
  //g_app.csdk = NxCreateCollisionSDK(NX_COLLISION_SDK_VERSION, *g_app.fsdk);

	//if (!g_app.csdk) {
  //  MessageBox(NULL,"Wrong NxCollision.DLL version?","Error",MB_ICONSTOP);
  //}
  g_app.rsdk = NxCreateRigidBodySDK(NX_RIGIDBODY_SDK_VERSION, *g_app.fsdk);
  if (!g_app.rsdk) {
    MessageBox(NULL,"Wrong NxRigidBodyF32.DLL version?","Error",MB_ICONSTOP);
  }

  g_app.scene = g_app.rsdk->createScene();
  g_app.scene->setUserCollisionDetection(this);
  //g_app.dynamics = g_app.csdk->createShapeSet();
  //g_app.statics = g_app.csdk->createShapeSet();

  no_bs = 0;

  bl = new Ball;
  //bl2 = new Ball;
  tb = new Table;
  tb2 = new Table2;
  gr = new Ground;
  net = new Net;

  rack = new Racket;

  reset();
  //bl->speed[1] = 0;
  /*bl->pos.data.x = -0.0f;
  bl->pos.data.y = 1.8f;
  bl->pos.data.z = -0.8f;
  bl->nxbody->setPosition(*bl->nxsphere->getPosition());
*/
  NxGravityEffector* grav = g_app.rsdk->createGravityEffector();
  grav->setGravity(NxrVec3(0.0f, -9.8f, -0.0f));
  g_app.scene->addEffector(*grav);
}


void Scene::reset() {
  bl->pos.data.x = 0.00f;
  bl->pos.data.y = 1.8f;
  //bl->pos.data.y = 0.8f;
  bl->pos.data.z = -0.3f;
  //bl->nxshape->isSphere()->setPosition(bl->pos);
  bl->nxbody->setPosition(bl->pos);
  bl->nxbody->setVelocity(NxrVec3(0.0f, 0.0f, -1.0f));
  //bl->nxbody->setVelocity(NxrVec3(0.0f, 0.0f, -1.0f));
}

void Scene::insertBall(float pos[]){
  if (no_bs < 0) {
    Ball* bln = new Ball;
    bln->pos.data.x = 0.0f;
    bln->pos.data.y = 1.5f;
    bln->pos.data.z = -0.8f;
    //bln->nxshape->isSphere()->setPosition(bln->pos);
    bln->nxbody->setPosition(bln->pos);
    b_array[no_bs++] = bln;
  }
}

void Scene::renderStatic() {
  if (tb && gr) {
    gr->render(); 
  }
}

void Scene::renderDynamic() {
  if (bl) {
    tb->render();
    tb2->render();
    bl->render();
    rack->render();
    //bl2->render();
    for(int i=0;i<no_bs;i++) {
      b_array[i]->render();
    }
    bl->drawShadow();
	net->render();
  }
}

void Scene::doTimeStep() {
  processInput();

  g_app.scene->run(0.005f);
  
  // Passe die Positionen der Shapes und Generalobjects an (neue Werte von Bodies)
  
  bl->updatePosition();

  if (bl->color[1] < 1.0) bl->color[1]+=0.1f;
  if (bl->color[2] < 0.8) bl->color[2]+=0.1f;
  if (g_app.netcolor[1] < 1.0) g_app.netcolor[1]+=.1f;
  if (g_app.netcolor[2] < 1.0) g_app.netcolor[2]+=.1f;
}

void Scene::finish() {
  g_app.scene->release();
  g_app.fsdk->release();
  g_app.rsdk->release();
}

Scene::~Scene() {
  delete tb;
  delete tb2;
  delete bl;
  delete gr;
  delete rack;
  for(int i=0;i<no_bs;i++) {
    delete b_array[i];
  }
}

void Scene::processInput() {
  int mx=0,my=0,mz=0;
  if (g_app.mcap.GetAxis(mx,my,mz)) {
    rack->pos.data.x -= (float)mx/g_app.mouseXFactor;
    rack->pos.data.z -= (float)my/g_app.mouseXFactor;

    //g_app.ego.eyeposition[1] += (float)mz/(10*g_app.mouseXFactor);
    //if (but1 == 0) {
      rack->increaseShootAngle((float)mz/7);
      //rack->addPower(mz/1000);
    //}
  }
  rack->restrictRange();
  adjustEgoToRacket();
  
  float ycp = bl->pos.data.y;
  
  if (ycp > 1.2f) ycp = 1.2f;
  else if (ycp < 0.76f) ycp = 0.76f;

  rack->pos.data.y = ycp;

  unsigned char but1,but2;
  if (g_app.mcap.GetButtons(but1,but2)) {
    if (but2 != 0) {
       rack->addPower(0.1f);
    }
     if (but1 != 0) {
      rack->reducePower(0.1f);
     }
  }
  
  if (tableUp)
    tb2->setUp();
  else
    tb2->setDown();
}

void Scene::adjustEgoToRacket() {
  float dx = rack->pos.data.x - g_app.ego.eyeposition[0];
  if (dx > 0.5) {
    g_app.ego.eyeposition[0] = rack->pos.data.x - 0.5f;
  }
  else if (dx < -0.5) {
    g_app.ego.eyeposition[0] = rack->pos.data.x + 0.5f;
  }

  float dz = g_app.ego.eyeposition[2] - rack->pos.data.z;
  if (dz > -0.6f) {
    g_app.ego.eyeposition[2] = rack->pos.data.z - 0.6f;
  }
  else if (dz < -1.5f) {
    g_app.ego.eyeposition[2] = rack->pos.data.z - 1.5f;
  }

}

void Scene::tableOrientation(bool up) {
  tableUp = up;
}