// scene.h

// Scene class constructs a scene graph and wrappes physic calculations

#ifndef _SCENE_H_
#define _SCENE_H_

#include "racket.h"

class Scene : public NxUserContactReport, public NxUserCollisionDetection
{
public:
  void init();
  void renderStatic();
  void renderDynamic();
  void doTimeStep();
  void processInput();
  void adjustEgoToRacket();
  void finish();
  void reset();
  ~Scene();

  void insertBall(float pos[3]);
  void tableOrientation(bool up);

  void contact(NxShape& s1, NxShape& s2, NxcReal separation, 
	  const NxcVec3& contactPoint, const NxcVec3& contactNormal);

  void invoke(NxScene& scene);
  Racket *rack;

private:
  Ball* bl;
  Table* tb;
  Table2* tb2;
  Ground* gr;
  Net *net;
  Ball* b_array[1000];
  int no_bs;
  bool tableUp;
};

#endif
