// texture.cpp

#include "stdafx.h"


#include "pingpong.h"

#include "texture.h"

extern NxFoundationSDK* fsdk;
extern NxCollisionSDK* csdk;


Texture::Texture(char *fn)
{
  char errtxt[300];
  m_hBmp = (HBITMAP)LoadImage(NULL,fn,IMAGE_BITMAP,0,0,LR_LOADFROMFILE | LR_CREATEDIBSECTION);
  if (m_hBmp == NULL) {
    sprintf(errtxt,"ERROR couldn't find file %s.",fn);
    MessageBox(NULL,errtxt,"Error",MB_OK | MB_ICONSTOP);
  }
  else {
    GetObject(m_hBmp, sizeof(BITMAP), (LPSTR)&m_bm);
    m_sx = m_bm.bmWidth;
    m_sy = m_bm.bmHeight;
    glGenTextures(1,&m_texname);
  }
}

void Texture::loadGL()
{
  glBindTexture(GL_TEXTURE_2D,m_texname);
  glTexImage2D(GL_TEXTURE_2D,0,3,m_bm.bmWidth,m_bm.bmHeight,0,GL_BGR_EXT,GL_UNSIGNED_BYTE,m_bm.bmBits);
}

void Texture::applyGL()
{
  glBindTexture(GL_TEXTURE_2D,m_texname);
}

Texture::~Texture()
{
  glDeleteTextures(1,&m_texname);
  DeleteObject(m_hBmp);
}
